package com.hzya.frame.plugin.lets.plugin.adjust;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.plugin.lets.ofsvo.QueryOfsStockinOrderRequestVO;
import com.hzya.frame.plugin.lets.util.PushDataByU8cUtil;
import com.hzya.frame.plugin.lets.util.SaveOrUpdateBusinessLogUtil;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.dao.IIntegrationTaskLivingDetailsDao;
import com.hzya.frame.ttxofs.dto.InterfaceParamDto;
import com.hzya.frame.ttxofs.dto.stock.StockinOrderSearchResponse;
import com.hzya.frame.ttxofs.service.OfsUnifiedService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.locks.ReentrantLock;

public class AdjustInPluginInitializer extends PluginBaseEntity {
    Logger logger = LoggerFactory.getLogger(AdjustInPluginInitializer.class);

    private static final ReentrantLock LOCK = new ReentrantLock(true);

    @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "com.hzya.frame.plugin.lets.plugin.adjust.AdjustInPluginInitializer";
    }

    @Override
    public String getPluginName() {
        return "丽知：OFS调整入库--->U8C其它入库";
    }

    @Override
    public String getPluginLabel() {
        return "丽知：OFS调整入库--->U8C其它入库";
    }

    @Override
    public String getPluginType() {
        return "1";
    }

    @Autowired
    private IIntegrationTaskLivingDetailsDao iIntegrationTaskLivingDetailsDao;
    @Autowired
    private PushDataByU8cUtil pushDataByU8cUtil;
    @Autowired
    private SaveOrUpdateBusinessLogUtil saveOrUpdateBusinessLogUtil;

    @Autowired
    private OfsUnifiedService ofsUnifiedService;

    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) throws Exception {
        return null;
    }


    /**
     * 默认推送
     */
    public void start() {
        try {
            //获取当前时间
            Date currentDate = new Date();
            Date startTime = DateUtil.offset(currentDate, DateField.MINUTE, -10);
            Date endTime = DateUtil.offset(currentDate, DateField.MINUTE, -2);
            String startTimeStr = DateUtil.format(startTime, "yyyy-MM-dd HH:mm:ss");
            String endTimeStr = DateUtil.format(endTime, "yyyy-MM-dd HH:mm:ss");

            QueryOfsStockinOrderRequestVO queryOfsStockinOrderRequestVO = new QueryOfsStockinOrderRequestVO();
            queryOfsStockinOrderRequestVO.setCreated_start("2024-08-05 00:00:00");
            queryOfsStockinOrderRequestVO.setCreated_end("2024-08-09 23:59:59");
            queryOfsStockinOrderRequestVO.setCompanyCode("SHXM");
//            queryOfsTransferOrderRequestVO.setStatus("900");//状态 500待同步 510已同步 700收货中 900入库完成 911作废 100订单池 200暂挂 400待合单 410待出库单出库
            queryOfsStockinOrderRequestVO.setPageNo(1L);
            queryOfsStockinOrderRequestVO.setPageSize(500L);
            List<StockinOrderSearchResponse.StockinOrder> data = queryOfsStockinOrder(queryOfsStockinOrderRequestVO);
            System.out.println(data);

            //过滤日志

            //推送


        } catch (Exception e) {
            logger.error("丽知：OFS调整入库--->U8C其它入库,start()方法报错：", e);
        }
    }

    /**
     * 按单号
     */
    public void start(String stockinNo) {
        try {
        } catch (Exception e) {
            logger.error("丽知：OFS调整入库--->U8C其它入库,start(String goodsName)方法报错：", e);
        }

    }

    /**
     * 按时间区间
     */
    public void start(String startTime, String endTime) {
        try {
            Date business_start = DateUtil.parse(startTime);
            Date business_end = DateUtil.parse(endTime);
            String start = DateUtil.format(business_start, "yyyy-MM-dd") + " 00:00:00";
            String end = DateUtil.format(business_end, "yyyy-MM-dd") + " 23:59:59";
        } catch (Exception e) {
            logger.error("丽知：OFS调整入库--->U8C其它入库,start(String startTime, String endTime)方法报错：", e);
        }
    }


    public List<StockinOrderSearchResponse.StockinOrder> queryOfsStockinOrder(QueryOfsStockinOrderRequestVO queryOfsStockinOrderRequestVO) throws Exception {
        InterfaceParamDto interfaceParamDto = new InterfaceParamDto();
        interfaceParamDto.setApi("ofs.receipt.search");
//        queryOfsStockinOrderRequestVO.setInternalInstructionType("ADJUST");//入库单类型 SALES销售 EXCHANGE换货 REISSUE补发RETURN销退 PURCHASE采购 PURCHASE_RETURN采退 TRANSFER调拨 WORK_ORDER加工 OTHER其他 ADJUST调整 EXCHANGE换货
        queryOfsStockinOrderRequestVO.setClientCode("LETS");
        interfaceParamDto.setData(JSON.toJSONString(queryOfsStockinOrderRequestVO));
        StockinOrderSearchResponse stockinOrderSearchResponse = (StockinOrderSearchResponse) ofsUnifiedService.unified(interfaceParamDto);
        System.out.println(stockinOrderSearchResponse);
        if(stockinOrderSearchResponse.getData()==null||stockinOrderSearchResponse.getData().size()==0){
            return null;
        }
        //过滤ADJUST调整
        List<StockinOrderSearchResponse.StockinOrder> adjustList=new ArrayList<>();
        for (StockinOrderSearchResponse.StockinOrder datum : stockinOrderSearchResponse.getData()) {
            StockinOrderSearchResponse.StockinOrder.StockinH header = datum.getHeader();
            if("ADJUST".equals(header.getInternalInstructionType())){
                adjustList.add(datum);
            }
        }
        return adjustList;
    }
}
