package com.hzya.frame.plugin.lets.util;

import cn.hutool.core.lang.Assert;

import com.hzya.frame.sysnew.integtationTaskLivingDetails.dao.IIntegrationTaskLivingDetailsDao;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.uuid.UUIDLong;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

//保存或者更新业务日志

@Component
public class SaveOrUpdateBusinessLogUtil {

    @Autowired
    private IIntegrationTaskLivingDetailsDao iIntegrationTaskLivingDetailsDao;
    private static final Object insertOrUpdateLock = new Object();

    /**
     * 保存或者更新
     *
     * @param integrationTaskLivingDetailsEntity 提交参数
     */
    public void saveOrUpdate(IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity) {
        Assert.notNull(integrationTaskLivingDetailsEntity, "integrationTaskLivingDetailsEntity不能为空");
        Assert.notNull(integrationTaskLivingDetailsEntity.getRootAppPk(), "源系统单号不能为空");
        Assert.notNull(integrationTaskLivingDetailsEntity.getPluginId(), "场景id不能为空");

        IntegrationTaskLivingDetailsEntity integrationTaskLivingDetails = null;
        IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity1 = new IntegrationTaskLivingDetailsEntity();
        integrationTaskLivingDetailsEntity1.setRootAppPk(integrationTaskLivingDetailsEntity.getRootAppPk());
        integrationTaskLivingDetailsEntity1.setPluginId(integrationTaskLivingDetailsEntity.getPluginId());
        List<IntegrationTaskLivingDetailsEntity> integrationTaskLivingDetailsEntities = iIntegrationTaskLivingDetailsDao.query(integrationTaskLivingDetailsEntity1);
        if (integrationTaskLivingDetailsEntities != null && integrationTaskLivingDetailsEntities.size() > 0) {
            integrationTaskLivingDetails = integrationTaskLivingDetailsEntities.get(0);
        }
        if (integrationTaskLivingDetails != null) {
            //存在
            synchronized (insertOrUpdateLock) {
                integrationTaskLivingDetailsEntity.setId(integrationTaskLivingDetails.getId());
                updateSuccessMessage(integrationTaskLivingDetailsEntity);
//                 iIntegrationTaskLivingDetailsDao.update("com.hzya.frame.sysnew.integtationTaskLivingDetails.dao.impl.IntegrationTaskLivingDetailsDaoImpl.entity_updatebyid", integrationTaskLivingDetailsEntity);
                iIntegrationTaskLivingDetailsDao.update(integrationTaskLivingDetailsEntity);
            }
        } else {
            //不存在
            Long uuid = UUIDLong.longUUID();
            integrationTaskLivingDetailsEntity.setId(String.valueOf(uuid));
            updateSuccessMessage(integrationTaskLivingDetailsEntity);
            IntegrationTaskLivingDetailsEntity save = iIntegrationTaskLivingDetailsDao.save(integrationTaskLivingDetailsEntity);
            System.out.println("save = " + save);
        }
    }

    /**
     * 修改成功消息
     *
     * @author liuyang
     */
    private void updateSuccessMessage(IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity) {
        if (integrationTaskLivingDetailsEntity != null) {
            if ("Y".equals(integrationTaskLivingDetailsEntity.getNewState())) {
                //成功
                integrationTaskLivingDetailsEntity.setRootAppNewData("success");
                integrationTaskLivingDetailsEntity.setNewTransmitInfo("success");
                /**
                 * integrationTaskLivingDetailsEntity.setRoot_app_new_data(JSON.toJSONString(searchPurchaseReceiptOrder));
                 * integrationTaskLivingDetailsEntity.setNew_transmit_info(cgrkApi);
                 */
            }
        }
    }

    /**
     * 根据明细id查询明细信息
     *
     * @author liuyang
     */
    public IntegrationTaskLivingDetailsEntity queryIntegrationTaskLivingDetailsEntity(String integration_task_living_details_id) {
        Assert.notNull(integration_task_living_details_id, "业务明细id不能为空");
        IntegrationTaskLivingDetailsEntity integrationTaskLivingDetailsEntity = iIntegrationTaskLivingDetailsDao.get(integration_task_living_details_id);
        Assert.notNull(integrationTaskLivingDetailsEntity, "根据主键id没有查询到明细信息");
        return integrationTaskLivingDetailsEntity;
    }
}
