package com.hzya.frame.ttxofs.basics;

import com.hzya.frame.ttxofs.dto.ofsTransferOrderSearch.OFSTranseferOrderSearchResponse;
import com.hzya.frame.ttxofs.dto.ofssaleorderoutsearch.SaleOutReturnMessageDto;
import com.hzya.frame.ttxofs.dto.ofssalesordersearch.SaleReturnMessageDto;
import com.hzya.frame.ttxofs.dto.stock.StockinOrderSearchResponse;

import java.util.HashMap;
import java.util.Map;

/**
 * api与dto的对应关系
 *
 * @Author：liuyang
 * @Package：com.hzya.frame.ttxofs.basics
 * @Project：kangarooDataCenterV3
 * @name：CacheMap
 * @Date：2024/7/30 11:51
 * @Filename：CacheMap
 */
public class ApiDtoCacheMap {

    public static final Map<String, ReturnMessageBasics> apiDtoCacheMap = new HashMap();

    static {
        apiDtoCacheMap.put("ofs.salesOrder.search", new SaleReturnMessageDto());
        apiDtoCacheMap.put("ofs.shipment.search", new SaleOutReturnMessageDto());
        apiDtoCacheMap.put("ofs.receipt.search", new StockinOrderSearchResponse());//入库单查询
        apiDtoCacheMap.put("ofs.transferOrder.search", new OFSTranseferOrderSearchResponse());//调拨订单
    }
}
