package com.hzya.frame.ttxofs.util;

import cn.hutool.core.util.StrUtil;
import com.hzya.frame.ttxofs.OfsHexUtil;
import com.hzya.frame.ttxofs.dto.InterfaceParamDto;

/**
 * OFS请求URl的转换处理
 *
 * @Author：liuyang
 * @Package：com.hzya.frame.ttxofs.util
 * @Project：kangarooDataCenterV3
 * @name：UtlTransUtil
 * @Date：2024/7/30 12:09
 * @Filename：UtlTransUtil
 */
public class UrlTransUtil {
    /**
     * Url的转换与拼接
     */
    public static String urlTrans(InterfaceParamDto interfaceParamDto) {
        String bashHttpUrl = interfaceParamDto.getBashHttpUrl();
        //2024年7月30日 12:16:38生成签名
        OfsHexUtil ofsHexUtil = new OfsHexUtil();
        String sign = ofsHexUtil.sign(interfaceParamDto.getApi(), interfaceParamDto.getData(), interfaceParamDto.getFormat(), interfaceParamDto.getAppKey(), interfaceParamDto.getV(), interfaceParamDto.getSecret(), interfaceParamDto.getTimestamp());
        return StrUtil.format(bashHttpUrl + "?api={}&format={}&appKey={}&v={}&sign={}&timestamp={}", interfaceParamDto.getApi(), interfaceParamDto.getFormat(), interfaceParamDto.getAppKey(), interfaceParamDto.getV(), sign, interfaceParamDto.getTimestamp());
    }
}